#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace FallingBlockPuzzle {

	public class FallingBlockPuzzle : Microsoft.Xna.Framework.Game {
		readonly GraphicsDeviceManager graphics;
		readonly ContentManager content;

		readonly Randomizer randomizer;
		readonly Blocks field;
		readonly BlocksVisual blocksVisual;
		readonly PieceVisual currentPieceVisual;
		readonly PieceVisual nextPieceVisual;
		readonly PiecesVisual freefallPiecesVisual;
		readonly PieceControl piece;

		readonly StageState state = new StageState();

		public FallingBlockPuzzle() {
			graphics = new GraphicsDeviceManager(this);
			content = new ContentManager(Services);
			field = new Blocks(24, 32);
			Components.Add(piece = new PieceControl(this, state, field));
			Components.Add(currentPieceVisual = new PieceVisual(this, content, piece.Pieces.Current));
			Components.Add(nextPieceVisual = new PieceVisual(this, content, piece.Pieces.Next));
			Components.Add(freefallPiecesVisual = new PiecesVisual(this, content, piece.Pieces.Freefalls));
			Components.Add(blocksVisual = new BlocksVisual(this, content, field, piece));
			Components.Add(new PieceInput(this, state, field, piece.Pieces));
			randomizer = new Randomizer(field);
			//randomizer.Randomize(4);
		}
		protected override void Initialize() {
			base.Initialize();
		}
		protected override void LoadGraphicsContent(bool loadAllContent) {
			if (loadAllContent) {
			}
		}
		protected override void UnloadGraphicsContent(bool unloadAllContent) {
			if (unloadAllContent) {
				content.Unload();
			}
		}

		protected override void Update(GameTime gameTime) {
			if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
				this.Exit();
			base.Update(gameTime);
		}
		protected override void Draw(GameTime gameTime) {
			graphics.GraphicsDevice.Clear(Color.CornflowerBlue);
			base.Draw(gameTime);
		}
	}
}
